package com.sample;

import org.drools.runtime.StatefulKnowledgeSession;
import org.drools.runtime.process.WorkItem;
import org.drools.runtime.process.WorkItemHandler;
import org.drools.runtime.process.WorkItemManager;

import java.io.File;
import java.util.HashMap;
import java.util.Map;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Attr;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

import org.w3c.dom.NodeList;
import org.w3c.dom.Node;


public class JobArchiveWrite implements WorkItemHandler {
	
	StatefulKnowledgeSession session;
	
	public JobArchiveWrite (StatefulKnowledgeSession ksession){
		session = ksession;
	}

	public void executeWorkItem(WorkItem workItem, WorkItemManager manager) {

		final WorkItem work = workItem;
		final WorkItemManager itemManager = manager;
		
		boolean retry = (Boolean)workItem.getParameter("retry");
		retry = false;
		/* new Thread(new Runnable() {

		      public void run() {*/

		// extract parameters
		System.out.println("Executing JobArchiveWrite Node");

		try {
			String src = JobParameters.getSource();
			String dst = JobParameters.getDestination();
			int pid = JobParameters.getProcessInstanceID();
			
			if(src == "exception") {
				throw new Exception();
			}
			
			DocumentBuilderFactory docFactory = DocumentBuilderFactory
					.newInstance();
			DocumentBuilder docBuilder = docFactory.newDocumentBuilder();

			// root elements
			Document doc = docBuilder.newDocument();
			Element job = doc.createElement("job");
			doc.appendChild(job);

			Attr attr = doc.createAttribute("pid");
			attr.setValue(Integer.toString(pid));
			job.setAttributeNode(attr);

			Element pidElement = doc.createElement("PID");
			pidElement.appendChild(doc.createTextNode(workItem.getProcessInstanceId() + ""));
			job.appendChild(pidElement);
			
			Element srcElement = doc.createElement("src");
			srcElement.appendChild(doc.createTextNode(src));
			job.appendChild(srcElement);
			
			Element dstElement = doc.createElement("dst");
			dstElement.appendChild(doc.createTextNode(dst));
			job.appendChild(dstElement);
			
			Element knowledgesession = doc.createElement("session");
			knowledgesession.appendChild(doc.createTextNode(session.toString()));
			job.appendChild(knowledgesession);
			
			 //throw new Exception();
			
			
			// write the content into xml file
			TransformerFactory transformerFactory = TransformerFactory
					.newInstance();
			Transformer transformer = transformerFactory.newTransformer();
			DOMSource source = new DOMSource(doc);
			StreamResult result = new StreamResult(new File("C:\\file.xml")); //change file location

			// Output to console for testing
			// StreamResult result = new StreamResult(System.out);
			//StreamResult result =  new StreamResult(System.out);
			transformer.transform(source, result);

			System.out.println("File saved!");

		} catch (ParserConfigurationException pce) {
			session.signalEvent("Sign", null);
			pce.printStackTrace();

		} catch (TransformerException tfe) {
			session.signalEvent("Sign", null);
			tfe.printStackTrace();
		} catch (Exception ex){
			//session.signalEvent("Sign", null);
			retry = true;
			//abortWorkItem(work, itemManager);
			//ex.printStackTrace();
		}
		
		
		System.out.println("Done with JobArchiveWrite");
		
		Map workItemResults = new HashMap();
		if(!retry){
			workItemResults.put("result", true);
		} else {
			workItemResults.put("result", false);
		}
		workItemResults.put("retry", retry);
		
		itemManager.completeWorkItem(work.getId(), workItemResults);
		
		//itemManager.completeWorkItem(work.getId(), null);
		//      }
		 // }).start();
	}
	


	

	@Override
	public void abortWorkItem(WorkItem workItem, WorkItemManager manager) {

		// Do nothing, notifications cannot be aborted
		// session.signalEvent("TimeOut", 5);
		System.out.println("Aborting");
		session.signalEvent("Sign", null);
	}
}
