package com.sample;

import java.io.File;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.drools.KnowledgeBase;
import org.drools.builder.KnowledgeBuilder;
import org.drools.builder.KnowledgeBuilderFactory;
import org.drools.builder.ResourceType;
import org.drools.event.knowledgebase.KnowledgeBaseEventManager;
import org.drools.io.ResourceFactory;
import org.drools.runtime.StatefulKnowledgeSession;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

/**
 * This is a sample file to launch a process.
 */
public class SignalEvent {
	
	static long Id;
	/*
	public SignalEvent(int instanceId){
		Id = instanceId;
	}*/

	public static final void main(String[] args) throws Exception {
		// load up the knowledge base
		KnowledgeBase kbase = readKnowledgeBase();
		StatefulKnowledgeSession ksession = kbase.newStatefulKnowledgeSession();
		ReadXMLFile();
		System.out.println(Id);
		
		//KnowledgeBaseEventManager k;
		
		/*for(StatefulKnowledgeSession ks: kbase.getStatefulKnowledgeSessions()){
			System.out.println(ks.toString());
		}*/
		ksession.getWorkItemManager().registerWorkItemHandler("Signaling", new Signaling(ksession.getProcessInstance(Id)));
		/*ksession.getWorkItemManager().registerWorkItemHandler("Signaling", new Signaling(ksession.getProcessInstance(ProcessMain.Id)));*/
		//StatefulKnowledgeSession k = ProcessMain.session;
		// start a new process instance
		ksession.startProcess("com.signal.bpmn");
	}

	private static KnowledgeBase readKnowledgeBase() throws Exception {
		KnowledgeBuilder kbuilder = KnowledgeBuilderFactory.newKnowledgeBuilder();
		kbuilder.add(ResourceFactory.newClassPathResource("externalSignal.bpmn"), ResourceType.BPMN2);
		return kbuilder.newKnowledgeBase();
	}
	
	 
	public static String ReadXMLFile()  {
		String knowledgesession = null;
		  try {
	 
			//Name of file that you are currently reading
			File fXmlFile = new File("c:\\file.xml");
			DocumentBuilderFactory dbFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder dBuilder = dbFactory.newDocumentBuilder();
			Document doc = dBuilder.parse(fXmlFile);
			doc.getDocumentElement().normalize();
	 
			System.out.println("Root element :" + doc.getDocumentElement().getNodeName());
			NodeList nList = doc.getElementsByTagName("job");
			System.out.println("-----------------------");
	 
			for (int temp = 0; temp < nList.getLength(); temp++) {
	 
			   Node nNode = nList.item(temp);
			   if (nNode.getNodeType() == Node.ELEMENT_NODE) {
	 
			      Element eElement = (Element) nNode;
	 
			      System.out.println("KnowledgeSession : " + getTagValue("session", eElement));
			      knowledgesession = getTagValue("session", eElement);
			      System.out.println("PID : " + getTagValue("PID", eElement));
			      Id = Long.valueOf(getTagValue("PID", eElement));
	 
			   }
			}
			
		  } catch (Exception e) {
			e.printStackTrace();
		  }
		  return knowledgesession;
	  }
	 
	  private static String getTagValue(String sTag, Element eElement) {
		NodeList nlList = eElement.getElementsByTagName(sTag).item(0).getChildNodes();
	        Node nValue = (Node) nlList.item(0);
	 
		return nValue.getNodeValue();
	  }
	 
	
}